ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.9 by root, Tue Dec 7 20:03:15 2010 UTC vs.
Revision 1.20 by root, Mon Dec 13 17:35:51 2010 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 11PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
12PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 13PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 14PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 15PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 16
19ARCH="$(uname -m)" 17ARCH="$(uname -m)"
20 18
21case "$ARCH" in 19case "$ARCH" in
22 i*86 | x86_64 | amd64 ) 20 i*86 | x86_64 | amd64 )
23 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 21 #PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
22 PERL_OPTIMIZE="$PERL_OPTIMIZE" # x86/amd64
24 case "$ARCH" in 23 case "$ARCH" in
25 i*86 ) 24 i*86 )
26 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
27 ;; 26 ;;
28 esac 27 esac
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 36
38# some configuration options for modules 37# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 38export PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
52postconfigure() { : ; } 51postconfigure() { : ; }
53postbuild() { : ; } 52postbuild() { : ; }
54postinstall() { : ; } 53postinstall() { : ; }
55 54
56# now source user config, if any 55# now source user config, if any
56if [ "$STATICPERLRC" ]; then
57 . "$STATICPERLRC"
58else
57[ -r /etc/staticperlrc ] && . /etc/staticperlrc 59 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
58[ -r ~/.staticperlrc ] && . ~/.staticperlrc 60 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
59[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 61 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
62fi
60 63
61############################################################################# 64#############################################################################
62# support 65# support
66
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
71export LC_ALL=C # just to be on the safe side
63 72
64# set version in a way that Makefile.PL can extract 73# set version in a way that Makefile.PL can extract
65VERSION=VERSION; eval \ 74VERSION=VERSION; eval \
66$VERSION=0.1 75$VERSION=0.911
67 76
68BZ2=bz2 77BZ2=bz2
69BZIP2=bzip2 78BZIP2=bzip2
70 79
71fatal() { 80fatal() {
104############################################################################# 113#############################################################################
105# clean 114# clean
106 115
107distclean() { 116distclean() {
108 verblock <<EOF 117 verblock <<EOF
109deleting everything installed by this script 118 deleting everything installed by this script (rm -rf $STATICPERL)
110EOF 119EOF
111 120
112 rm -rf "$STATICPERL" 121 rm -rf "$STATICPERL"
113} 122}
114 123
139 148
140 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 149 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
141 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 150 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
142 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 151 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 || fatal "$URL: unable to download" 152 || fatal "$URL: unable to download"
153 rm -f perl-$PERL_VERSION.tar.$BZ2
144 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 154 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
145 fi 155 fi
146 156
147 verblock <<EOF 157 verblock <<EOF
148unpacking perl 158unpacking perl
149EOF 159EOF
150 160
151 mkdir -p unpack 161 mkdir -p unpack
162 rm -rf unpack/perl-$PERL_VERSION
152 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xC unpack \ 163 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
153 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 164 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
154 chmod -R u+w unpack/perl-$PERL_VERSION 165 chmod -R u+w unpack/perl-$PERL_VERSION
155 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 166 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
156 rmdir -p unpack 167 rmdir -p unpack
157 fi 168 fi
158} 169}
159 170
160# similar to GNU-sed -i or perl -pi 171# similar to GNU-sed -i or perl -pi
161sedreplace() { 172sedreplace() {
162 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 173 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
174 rm -f "$2"
163 mv "$2~" "$2" 175 mv "$2~" "$2"
164} 176}
165 177
166configure() { 178configure() {
167 fetch 179 fetch
190 -Dusemymalloc=n \ 202 -Dusemymalloc=n \
191 -Uusedl \ 203 -Uusedl \
192 -Uusethreads \ 204 -Uusethreads \
193 -Uuseithreads \ 205 -Uuseithreads \
194 -Uusemultiplicity \ 206 -Uusemultiplicity \
195 -Duseperlio \
196 -Uusesfio \ 207 -Uusesfio \
197 -Uuseshrplib \ 208 -Uuseshrplib \
209 -Dcc="$PERL_CC" \
198 -Dcppflags="$PERL_CPPFLAGS" \ 210 -Dcppflags="$PERL_CPPFLAGS" \
199 -Dccflags="-g2 -fno-strict-aliasing" \ 211 -Dccflags="-g2 -fno-strict-aliasing" \
200 -Doptimize="$PERL_OPTIMIZE" \ 212 -Doptimize="$PERL_OPTIMIZE" \
201 -Dldflags="$PERL_LDFLAGS" \ 213 -Dldflags="$PERL_LDFLAGS" \
202 -Dlibs="$PERL_LIBS" \ 214 -Dlibs="$PERL_LIBS" \
215 -Dpager=/usr/bin/less \ 227 -Dpager=/usr/bin/less \
216 -Demail="$EMAIL" \ 228 -Demail="$EMAIL" \
217 -Dcf_email="$EMAIL" \ 229 -Dcf_email="$EMAIL" \
218 -Dcf_by="$EMAIL" \ 230 -Dcf_by="$EMAIL" \
219 $PERL_CONFIGURE \ 231 $PERL_CONFIGURE \
232 -Duseperlio \
220 -dE || fatal "Configure failed" 233 -dE || fatal "Configure failed"
221 234
222 sedreplace ' 235 sedreplace '
223 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 236 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
224 s/ *-fno-stack-protector */ /g 237 s/ *-fno-stack-protector */ /g
254 verblock <<EOF 267 verblock <<EOF
255installing $STATICPERL/src/perl-$PERL_VERSION 268installing $STATICPERL/src/perl-$PERL_VERSION
256to $PERL_PREFIX 269to $PERL_PREFIX
257EOF 270EOF
258 271
259 rm -rf "$PERL_PREFIX" 272 ln -sf "perl/bin/" "$STATICPERL/bin"
260 273 ln -sf "perl/lib/" "$STATICPERL/lib"
274
275 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
276 rm -rf "$PERL_PREFIX" # by this rm -rf
277
261 make install || fatal "make install: error while installing" 278 make install || fatal "make install: error while installing"
262 279
263 rcd "$PERL_PREFIX" 280 rcd "$PERL_PREFIX"
264 281
265 # create a "make install" replacement for CPAN 282 # create a "make install" replacement for CPAN
266 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 283 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
267make install UNINST=1 284make || exit
285
268if find blib/arch/auto -type f | grep -q -v .exists; then 286if find blib/arch/auto -type f | grep -q -v .exists; then
269 echo Probably an XS module, rebuilding perl 287 echo Probably an XS module, rebuilding perl
270 make perl 288 if make perl; then
289 mv perl "$PERL_PREFIX"/bin/perl~ \
271 rm -f "$PERL_PREFIX"/bin/perl 290 && rm -f "$PERL_PREFIX"/bin/perl \
272 make -f Makefile.aperl inst_perl 291 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
273 make -f Makefile.aperl map_clean 292 make -f Makefile.aperl map_clean
293 else
294 make -f Makefile.aperl map_clean
295 exit 1
296 fi
274fi 297fi
298
299make install UNINST=1
275EOF 300EOF
276 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 301 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
277 302
278 # trick CPAN into avoiding ~/.cpan completely 303 # trick CPAN into avoiding ~/.cpan completely
279 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 304 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
294 ' || fatal "error while initialising CPAN" 319 ' || fatal "error while initialising CPAN"
295 320
296 touch "$PERL_PREFIX/staticstamp.install" 321 touch "$PERL_PREFIX/staticstamp.install"
297 fi 322 fi
298 323
299 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall"; then 324 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
300 NOCHECK_INSTALL=+ 325 NOCHECK_INSTALL=+
301 instcpan $STATICPERL_MODULES 326 instcpan $STATICPERL_MODULES
302 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 327 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
303 328
304 postinstall || fatal "postinstall hook failed" 329 postinstall || fatal "postinstall hook failed"
355############################################################################# 380#############################################################################
356# main 381# main
357 382
358podusage() { 383podusage() {
359 echo 384 echo
385
360 if [ -e "$PERL_PREFIX/bin/perl" ]; then 386 if [ -e "$PERL_PREFIX/bin/perl" ]; then
361 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 387 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
362 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 388 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
363 2>/dev/null && exit 389 2>/dev/null && exit
364 fi 390 fi
391
365 # try whatever perl we can find 392 # try whatever perl we can find
366 perl -MPod::Usage -e \ 393 perl -MPod::Usage -e \
367 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 394 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
368 2>/dev/null && exit 395 2>/dev/null && exit
369 396
370 fatal "displaying documentation requires a working perl - try '$0 install' first" 397 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
371} 398}
372 399
373usage() { 400usage() {
374 podusage 0 401 podusage 0
375} 402}
385} 412}
386 413
387bundle() { 414bundle() {
388 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 415 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
389 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 416 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
417 CACHE="$STATICPERL/cache"
418 mkdir -p "$CACHE"
390 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 419 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
391} 420}
392 421
393if [ $# -gt 0 ]; then 422if [ $# -gt 0 ]; then
394 while [ $# -gt 0 ]; do 423 while [ $# -gt 0 ]; do
395 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 424 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
396 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 425 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
397 426
398 command="${1#--}"; shift 427 command="${1#--}"; shift
399 case "$command" in 428 case "$command" in
429 version )
430 echo "staticperl version $VERSION"
431 ;;
400 fetch | configure | build | install | clean | distclean) 432 fetch | configure | build | install | clean | distclean)
401 verblock <<EOF
402$command
403EOF
404 ( "$command" ) 433 ( "$command" )
405 ;; 434 ;;
406 instsrc ) 435 instsrc )
407 ( instsrc "$@" ) 436 ( instsrc "$@" )
408 exit 437 exit
422 exit 451 exit
423 ;; 452 ;;
424 mkperl ) 453 mkperl )
425 ( install ) 454 ( install )
426 bundle --perl "$@" 455 bundle --perl "$@"
456 exit
457 ;;
458 mkapp )
459 ( install )
460 bundle --app "$@"
427 exit 461 exit
428 ;; 462 ;;
429 help ) 463 help )
430 podusage 2 464 podusage 2
431 ;; 465 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines